**************************************************
* File:         dbctoxml.prg
* Class:        dbctoxml
* ParentClass:  Session
* BaseClass:    Session
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Author:    Michael Drozdov
* Company:   ICS Soft, Perm, Russia
* E-mail:    Mailto:Drozdov@ics.perm.su 
* Home Page: http://vfpdmur.narod.ru/
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Date:   07/31/02
* Revision History:
*   Date          Comment
*   07/31/02      Initial version started
**************************************************
*
#DEFINE CRLF		CHR(13) + CHR(10)
#DEFINE IDCANCEL	2

#DEFINE INIT_DATASESSION	2 &&<- Do not change this constant, if there is no necessity :-)
#DEFINE INIT_FLAGS			"8+16+512"
#DEFINE INIT_USESCHEMANAME	.T.
#DEFINE INIT_OUTPUTFORMAT	1

#DEFINE EXT_XSD				"xsd"
#DEFINE EXT_XML				"xml"
#DEFINE SEP_ERRTBLLIST		", "

#DEFINE LANG_LOCAL_LOC		.F.
#IF LANG_LOCAL_LOC
	#DEFINE ERR_PROPDBC_LOC			"    'cDatabase'"
	#DEFINE ERR_NOTABLES_LOC		"    : "
	#DEFINE MSG_CURTABLE_LOC		" : "
	#DEFINE MSG_STATESUCCESS_LOC	":   !"
	#DEFINE MSG_STATEERROR_LOC		":     ."

	#DEFINE MSG_PREFNUMBER_LOC		": "
	#DEFINE MSG_PREFMESSAGE_LOC		": "
	#DEFINE MSG_PREFOLEERR_LOC		"OLE : "
	#DEFINE MSG_PREFMETHOD_LOC		": "
	#DEFINE MSG_PREFLINE_LOC		": "
#ELSE 
	#DEFINE ERR_PROPDBC_LOC			"Empty propery 'cDatabase'"
	#DEFINE ERR_NOTABLES_LOC		"No tables in database: "
	#DEFINE MSG_CURTABLE_LOC		"Current table: "
	#DEFINE MSG_STATESUCCESS_LOC	"State: successful completed!"
	#DEFINE MSG_STATEERROR_LOC		"State: completed with error."

	#DEFINE MSG_PREFNUMBER_LOC		"Error: "
	#DEFINE MSG_PREFMESSAGE_LOC		"Message: "
	#DEFINE MSG_PREFOLEERR_LOC		"OLE error: "
	#DEFINE MSG_PREFMETHOD_LOC		"Method: "
	#DEFINE MSG_PREFLINE_LOC		"Line: "
#ENDIF

DEFINE CLASS DbcToXml AS Session

	cDatabase 				= "" 
	cSchemaLocation 		= ""
	cNameSpace 				= ""
	cPathOut 				= ""
	cListNotOpenedTables 	= ""
	nOutputFormat 			= INIT_OUTPUTFORMAT
	nFlags 					= INIT_FLAGS
	bUseSchemaName 			= INIT_USESCHEMANAME
	DataSession				= INIT_DATASESSION
	Name 					= "DbcToXml"
	PROTECTED cListNotOpenedTables
	PROTECTED bCancel

	PROCEDURE cdatabase_assign
		LPARAMETERS vNewVal
		IF Vartype(m.vNewVal) # 'C' OR Empty(m.vNewVal)
			RETURN
		ENDIF
		m.vNewVal = Lower(Alltrim(m.vNewVal))
		IF This.cDatabase == m.vNewVal
			RETURN
		ENDIF
		WITH This
			.CloseData() 
			.cDatabase = ""
		ENDWITH
		IF !File(m.vNewVal)
			RETURN
		ENDIF
		IF !DBused(m.vNewVal)
			OPEN DATABASE (m.vNewVal) SHARED 
		ENDIF
		IF !DBused(m.vNewVal)
			RETURN
		ENDIF
		SET DATABASE TO (m.vNewVal)
		This.cDatabase = m.vNewVal
	ENDPROC

	PROTECTED PROCEDURE closedata
		IF !Empty(This.cDatabase)
			IF DBused(This.cDatabase)
				SET DATABASE TO (This.cDatabase)
				CLOSE DATABASES  
			ENDIF
		ENDIF
	ENDPROC

	PROCEDURE convert
		LPARAMETERS toProgressbar, toLabelCurState
		This.cListNotOpenedTables = ""
		*
		*-- Check cDatabase property
		IF Empty(This.cDatabase)
			=MessageBox(ERR_PROPDBC_LOC, 16)
			RETURN .F.
		ENDIF
		IF !DBused(This.cDatabase)
			OPEN DATABASE (This.cDatabase) SHARED 
		ENDIF
		IF !DBused(This.cDatabase)
			RETURN .F.
		ENDIF
		*
		*-- Get list of tables in database
		SET DATABASE TO (This.cDatabase)
		LOCAL ARRAY laTables[1]
		LOCAL lnTables
		lnTables = ADBObjects(laTables, "TABLE")
		IF lnTables = 0
			=MessageBox(ERR_NOTABLES_LOC+This.cDatabase, 16)
			RETURN .F.
		ENDIF
		LOCAL lnIndex, lcAlias, lcDbc, lcTable ;
			,lbOpenTbl, lnRetVal ;
			,lcPathOut, lcSchemaName, lcSchemaLocation ;
			,lcOldPath, lcSafety, lnFlags ;
			,lbIsProgressbar, lbIsLabelCurState
		STORE "" TO ;
			lcSchemaName ;
			,lcSchemaLocation
		*
		*-- Check display objects	
		lbIsProgressbar = (Vartype(toProgressbar) = 'O')
		lbIsLabelCurState = (Vartype(toLabelCurState) = 'O')
		*
		*-- Check properties: nFlags, cPathOut, cSchemaLocation
		lnFlags = This.nFlags
		IF Vartype(lnFlags) = 'C'
			lnFlags = Evaluate(lnFlags)
		ENDIF
		lcPathOut = This.cPathOut
		IF !Empty(lcPathOut)
			lcPathOut = Addbs(lcPathOut)
		ENDIF
		IF !Empty(This.cSchemaLocation)
			IF Right(This.cSchemaLocation, 1) # "/"
				This.cSchemaLocation = This.cSchemaLocation+"/"
			ENDIF
		ENDIF
		*
		*-- Set current directory to database folder
		lcOldPath = FullPath(Curdir(""))
		SET DEFAULT TO (Leftc(This.cDatabase, Ratc("\", This.cDatabase)))
		IF lbIsProgressbar
			*
			*-- Init progress
			toProgressbar.Reset(lnTables)
		ENDIF
		lcDbc = JustStem(This.cDatabase)
		*
		*-- Clear Cancel
		This.bCancel = .F.
		*
		*-- For each table in database
		FOR lnIndex = 1 TO Alen(laTables)
			lnRetVal = 0
			lcAlias = Chrtranc(Proper(laTables[lnIndex]), CHR(32), "_")
			lbOpenTbl = .F.
			IF lbIsLabelCurState
				toLabelCurState.Caption = MSG_CURTABLE_LOC+lcAlias
			ENDIF   
			IF lbIsProgressbar
				toProgressbar.Update(lnIndex)
			ENDIF
			*
			*-- Try open current table
			IF !Used(lcAlias)
				USE (lcDbc+"!"+lcAlias) IN 0 SHARED NOUPDATE
				lbOpenTbl = .T.   
			ENDIF
			IF Used(lcAlias)
				SELECT (lcAlias)
				*
				*-- Apply CursorToXML()
				IF This.bUseSchemaName
					lcSchemaName = lcPathOut+lcAlias+"."+EXT_XSD
					IF !Empty(This.cSchemaLocation)
						lcSchemaLocation = This.cSchemaLocation+lcSchemaName
					ENDIF
				ENDIF
				lnRetVal = CursorToXML(lcAlias, lcPathOut+lcAlias+"."+EXT_XML;
					,This.nOutputFormat, lnFlags, 0;
					,lcSchemaName, lcSchemaLocation, This.cNamespace)
				IF lnRetVal = 0
					This.cListNotOpenedTables = This.cListNotOpenedTables+lcAlias;
						+SEP_ERRTBLLIST
				ENDIF
				*
				*-- Close current table     
				IF lbOpenTbl
					USE IN (lcAlias)
				ENDIF
			ELSE
				This.cListNotOpenedTables = This.cListNotOpenedTables+lcAlias;
					+SEP_ERRTBLLIST
			ENDIF
			*
			*-- Check select cancel by user in case error
			IF This.bCancel
				EXIT
			ENDIF
		ENDFOR
		IF lbIsProgressbar
			*
			*-- Progress completed
			toProgressbar.Complete()
			toProgressbar.Update(0)
		ENDIF
		*
		*-- Restore current directory
		SET DEFAULT TO (lcOldPath)
		*
		*-- Check result
		LOCAL lbRetVal
		IF Empty(This.cListNotOpenedTables)
			lbRetVal = .T.
			IF lbIsLabelCurState
				toLabelCurState.Caption = MSG_STATESUCCESS_LOC
			ENDIF
		ELSE
			IF lbIsLabelCurState
				toLabelCurState.Caption = MSG_STATEERROR_LOC
			ENDIF
			LOCAL lnLastSep
			lnLastSep = Ratc(SEP_ERRTBLLIST, This.cListNotOpenedTables)
			IF lnLastSep > 0
				*
				*-- Remove last SEP_ERRTBLLIST
				This.cListNotOpenedTables = Leftc(This.cListNotOpenedTables, lnLastSep-1)
			ENDIF
			lbRetVal = .F.
		ENDIF	   
		RETURN lbRetVal
	ENDPROC

	PROCEDURE cpathout_assign
		LPARAMETERS vNewVal
		This.cPathOut = ""
		IF Vartype(m.vNewVal) = 'C' AND !Empty(m.vNewVal)
			m.vNewVal = Lower(Alltrim(m.vNewVal))
			IF !Directory(m.vNewVal)
				MKDIR (m.vNewVal)
			ENDIF
			IF Directory(m.vNewVal)
				This.cPathOut = m.vNewVal
			ENDIF
		ENDIF
	ENDPROC

	PROCEDURE getlistnotopenedtables
		RETURN This.cListNotOpenedTables 
	ENDPROC

	PROCEDURE Init
		IF This.DataSession <> 1
			SET DATASESSION TO This.DataSessionID
		ENDIF
		SET DELETED ON
		SET MULTILOCKS ON
		SET EXCLUSIVE OFF
		SET SAFETY OFF 
	ENDPROC

	PROCEDURE Destroy
		This.CloseData()
	ENDPROC

	PROCEDURE Error
		LPARAMETERS nError, cMethod, nLine
		IF Vartype(m.nError) # 'N'
			m.nError = 0
		ENDIF
		IF Vartype(m.cMethod) # 'C'
			m.cMethod = ""
		ENDIF
		IF Vartype(m.nLine) # 'N'
			m.nLine = 0
		ENDIF
		LOCAL lcMsg, lnErr
		LOCAL ARRAY laErr[1]
		lnErr = AError(laErr)
		lcMsg = MSG_PREFNUMBER_LOC + Ltrim(Str(laErr[1])) + CRLF
		lcMsg = lcMsg + MSG_PREFMESSAGE_LOC + laErr[2]
		IF InList(laErr[1], 1427, 1429) AND !Empty(laErr[3]) 
			lcMsg = lcMsg  + CRLF + MSG_PREFOLEERR_LOC + laErr[3]
		ENDIF
		IF !Empty(cMethod)
			lcMsg = lcMsg + CRLF + MSG_PREFMETHOD_LOC + cMethod
		ENDIF
		IF !Empty(nLine)
			lcMsg = lcMsg + CRLF + MSG_PREFLINE_LOC + Ltrim(Str(nLine))
		ENDIF
		IF IDCANCEL = MessageBox(lcMsg, 16+1, Iif(Type('ThisForm') = 'O', ThisForm.Caption, _SCREEN.Caption))
			This.bCancel = .T.
		ENDIF
	ENDPROC

ENDDEFINE
*
*-- EndDefine: dbctoxml
**************************************************
